/* modelBuildingTools - Software to create texture and shape models
   for Active Models

    Jesus Nuevo-Chiquero, University of Alcal, Spain. 2010
    jesus.nuevochiquero@gmail.com

    This file is part of 'modelBuildingTools'.

    modelBuildingTools is free software: you can redistribute it
    and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation, either version 3 of
    the License, or (at your option) any later version.

    modelBuildingTools is distributed in the hope that it will be
    useful, but WITHOUT ANY WARRANTY; without even the implied
    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with modelBuildingTools.  If not, see
    <http://www.gnu.org/licenses/>.

*/

#ifndef _BASIC_UTILS_HH_
#define _BASIC_UTILS_HH_

#include <string>
#include <sstream>
#include <iostream>
#include <iterator>

#include "cxcore.h"
#include "cv.h"
#include "highgui.h"


template <class T>
bool from_string(T& t, 
                 const std::string& s, 
                 std::ios_base& (*f)(std::ios_base&) = std::dec)
{
  std::istringstream iss(s);
  return !(iss >> f >> t).fail();
}

template <typename T>
std::string to_string(const T &thing) {
    std::stringstream os;
    os << thing;
    return os.str();
}

std::ostream& operator<<(std::ostream& os,  cv::Mat& v);

void print_arr(const CvArr *arr, bool transpose = false);

int read_image_mark_files(std::vector<std::string> inputs, bool use_bioid, 
			  std::vector<std::string>&imgfiles, 
			  std::vector<std::string>&marks);


#endif
